###############################################################################
##	Filename:	ExpFX.py
##	
##	Nano's Explosion Effects Enhancements Version 1.0
##	
##	Created:	03/11/2003 - NanoByte a.k.a Michael T. Braams
###############################################################################
import App
import Custom.NanoFX.ExplosionFX.ExpGfx
import Custom.NanoFX.ExplosionFX.ExpSfx

import Foundation

g_GfxSet		= { 
				"ExplosionGfx" : Custom.NanoFX.ExplosionFX.ExpGfx.GetFileNames("Explosions"),
				"ExpNovaGfx"   : Custom.NanoFX.ExplosionFX.ExpGfx.GetFileNames("ExpNova"),
				"ParticleGfx"  : Custom.NanoFX.ExplosionFX.ExpGfx.GetFileNames("Particles"),
				"NovaRingGfx"   : Foundation.GetFileNames("scripts/Custom/NanoFXv2/ExplosionFX/Gfx/NovaRing", 'tga'),
				"NovaSphereGfx"   : Foundation.GetFileNames("scripts/Custom/NanoFXv2/ExplosionFX/Gfx/NovaSphere", 'tga'),
				"NovaFlashGfx"   : Foundation.GetFileNames("scripts/Custom/NanoFXv2/ExplosionFX/Gfx/NovaFlash", 'tga')
				}		  
g_SfxSet		= { 
				"ExpSmallSfx"     : Custom.NanoFX.ExplosionFX.ExpSfx.GetSfxList("ExpSmall"),
				"ExpLargeSfx"     : Custom.NanoFX.ExplosionFX.ExpSfx.GetSfxList("ExpLarge"),
				"ExpNovaSfx"		: Custom.NanoFX.ExplosionFX.ExpSfx.GetSfxListNanoTwo("ExpNova"),
				"ExpCollisionSfx" : Custom.NanoFX.ExplosionFX.ExpSfx.GetSfxList("ExpCollision") 
				}

g_RandomExp		= App.g_kSystemWrapper.GetRandomNumber(len(g_GfxSet["ExplosionGfx"]))
g_LightsOff = []
g_GFX_FPS		= 32
g_ParticleControl = 0
g_SimultaneousControl = 0
CONST_MAXPARTICLES = Custom.NanoFXv2.NanoFX_Config.eFX_ParticleControl
CONST_MAXSIMULTANEOUS = 150

###############################################################################
## New Effect Controllers...
###############################################################################
###############################################################################
###############################################################################
## 32 Frame Collision Explosions,  Random pick of Explosions
###############################################################################
def GetNanoGfxFile(sGfxSet, sFolderPath):
	
	### Random File ###
		
	#if (sGfxSet == "ExplosionGfx"):
		#global g_RandomExp
		#g_RandomExp = g_RandomExp + 1
		#if (g_RandomExp >= len(g_GfxSet[sGfxSet])):
			#g_RandomExp = 0
		#iRandom = g_RandomExp
	#else:
	iRandom = App.g_kSystemWrapper.GetRandomNumber(len(g_GfxSet[sGfxSet]))

	strFile = sFolderPath + g_GfxSet[sGfxSet][iRandom]

	return strFile

def CreateNanoCollisionExp(fSize, vLocation, vDirection, pEffectRoot):
	
	### Create Controller ###
	pExplosion = App.AnimTSParticleController_Create()
	###
	### Setup Collision Effect ###
	pExplosion.AddColorKey(0.6, 1.0, 1.0, 1.0)
	pExplosion.AddColorKey(1.0, 0.0, 0.0, 0.0)
	pExplosion.AddAlphaKey(0.4, 1.0)
	pExplosion.AddAlphaKey(0.7, 0.5)
	pExplosion.AddAlphaKey(1.0, 0.0)
	pExplosion.AddSizeKey(0.0, 0.7 * fSize)
	pExplosion.AddSizeKey(0.2, 1.0 * fSize)
	pExplosion.AddSizeKey(0.6, 1.3 * fSize)
	pExplosion.AddSizeKey(0.9, 1.3 * fSize)
	pExplosion.AddSizeKey(1.0, 1.4 * fSize)
	pExplosion.SetEmitRadius(fSize * 0.25) 
	###
	### Setup Animation ###
	fFrequency = 0.2 
	pExplosion.SetEmitLife(g_GFX_FPS / 12)
	pExplosion.SetEmitFrequency(fFrequency)
	pExplosion.SetEffectLifeTime(1.0)
	###
	### Random Nano Explosion ###
	fRandomNum = App.g_kSystemWrapper.GetRandomNumber(len(g_GfxSet["ExplosionGfx"]))
	strFile = "scripts/Custom/NanoFX/ExplosionFX/Gfx/Explosions/" + g_GfxSet["ExplosionGfx"][fRandomNum]
	pExplosion.CreateTarget(strFile)
	### Setup Properties
	pExplosion.SetTargetAlphaBlendModes(0, 7)
	pExplosion.SetEmitPositionAndDirection(vLocation, vDirection)
	pExplosion.AttachEffect(pEffectRoot)
	###
	return App.EffectAction_Create(pExplosion)

###############################################################################
## 32 Frame Explosions,  Random pick of Explosions
###############################################################################
def CreateNanoExp(fLife, fSize, pEmitFrom, kEmitPos, kEmitDir, pAttachTo):
	
	### Create Controller ###	
	pExplosion = App.AnimTSParticleController_Create()
	###
	### Setup Explosion Effect ###
	pExplosion.AddColorKey(0.6, 1.0, 1.0, 1.0)
	pExplosion.AddColorKey(1.0, 0.0, 0.0, 0.0)
	pExplosion.AddAlphaKey(0.4, 1.0)
	pExplosion.AddAlphaKey(0.7, 0.5)
	pExplosion.AddAlphaKey(1.0, 0.0)
	fRandSize = App.g_kSystemWrapper.GetRandomNumber(50) * 0.01
	pExplosion.AddSizeKey(0.0, 0.1 * fSize + fRandSize)
	pExplosion.AddSizeKey(0.2, 0.5 * fSize + fRandSize)
	pExplosion.AddSizeKey(0.6, 1.6 * fSize + fRandSize)
	pExplosion.AddSizeKey(0.9, 2.0 * fSize + fRandSize)
	pExplosion.SetEmitRadius(fSize * 0.25)
	###
	### Setup Animation ###
	fFrequency = 0.2
	pExplosion.SetEmitLife(g_GFX_FPS / 12)
	pExplosion.SetEmitFrequency(fFrequency)
	pExplosion.SetEffectLifeTime(1.0)
	###
	### Random Nano Explosion ###
	global g_RandomExp
	g_RandomExp = g_RandomExp + 1
	if (g_RandomExp >= len(g_GfxSet["ExplosionGfx"])):
		g_RandomExp = 0
	strFile = "scripts/Custom/NanoFX/ExplosionFX/Gfx/Explosions/" + g_GfxSet["ExplosionGfx"][g_RandomExp]
	pExplosion.CreateTarget(strFile)
	###
	### Setup Properties ###
	pExplosion.SetTargetAlphaBlendModes(0, 7)
	pExplosion.SetEmitFromObject(pEmitFrom)
	if (kEmitDir != -1):
		pExplosion.SetEmitPositionAndDirection(kEmitPos, kEmitDir)
	pExplosion.SetInheritsVelocity(0)
	pExplosion.AttachEffect(pAttachTo)
	pExplosion.SetDetachEmitObject(0)
	###
	return App.EffectAction_Create(pExplosion)

###############################################################################
## 32 Frame Plume Exp Effect,  Random pick of Explosions
###############################################################################
def CreateNanoExpPlume(fConeAngle, fLife, fSize, pEmitFrom, kEmitPos, kEmitDir, pAttachTo):
	
	### Create Controller ###	
	pPlume = App.ExplosionPlumeController_Create()
	###
	### Setup Plume Effect ###
	pPlume.AddColorKey(0.0, 1.0, 1.0, 1.0)
	pPlume.AddColorKey(1.0, 0.0, 0.0, 0.0)
	pPlume.AddAlphaKey(0.4, 1.0)
	pPlume.AddAlphaKey(0.7, 0.5)
	pPlume.AddAlphaKey(1.0, 0.0)
	fRandSize = App.g_kSystemWrapper.GetRandomNumber(100) * 0.01
	pPlume.AddSizeKey(0.3, 0.2 * fSize + fRandSize)
	pPlume.AddSizeKey(1.0, 0.5 * fSize + fRandSize)
	pPlume.SetEmitRadius(fSize * 0.25) 
	###
	### Setup Animation ###
	fFrequency = 0.2
	pPlume.SetEmitLife(g_GFX_FPS / 21)
	pPlume.SetEmitFrequency(fFrequency)
	pPlume.SetEffectLifeTime(1.0)
	###
	### Random Nano Explosion ###
	global g_RandomExp
	g_RandomExp = g_RandomExp + 1
	if (g_RandomExp >= len(g_GfxSet["ExplosionGfx"])):
		g_RandomExp = 0
	strFile = "scripts/Custom/NanoFX/ExplosionFX/Gfx/Explosions/" + g_GfxSet["ExplosionGfx"][g_RandomExp]
	pPlume.CreateTarget(strFile)	
	###
	### Setup Properties ###
	pPlume.SetEmitFromObject(pEmitFrom)
	if (kEmitDir != -1):
		pPlume.SetEmitPositionAndDirection(kEmitPos, kEmitDir)
	pPlume.SetInheritsVelocity(0)
	pPlume.AttachEffect(pAttachTo)
	pPlume.SetUpRandomVelocity(fConeAngle, fSize / 10)
	pPlume.SetDetachEmitObject(0)
	###
	return App.EffectAction_Create(pPlume)

###############################################################################
## 32 Frame Warp Core Ring Explosions,  Random pick of Explosions
###############################################################################
def CreateNanoWarpCoreExp(fSize, fLife, pEmitFrom, bOwnsEmitFrom, pEffectRoot):
	
	### Create Controller ###	
	pExplosion = App.AnimTSParticleController_Create()
	###	
	### Setup Nova Explosion Effect ###
	pExplosion.AddColorKey(0.4, 1.0, 1.0, 1.0)
	pExplosion.AddColorKey(1.0, 0.0, 0.0, 0.0)
	pExplosion.AddAlphaKey(0.4, 1.0)
	pExplosion.AddAlphaKey(1.0, 0.0)
	pExplosion.AddSizeKey(0.0, 0.1 * fSize)
	pExplosion.AddSizeKey(0.2, 0.5 * fSize)
	pExplosion.AddSizeKey(0.6, 1.6 * fSize)
	pExplosion.AddSizeKey(0.9, 2.0 * fSize)
	###
	### Setup Animation ###
	fFrequency = 0.2
	pExplosion.SetEmitLife(g_GFX_FPS / 11)
	pExplosion.SetEmitFrequency(fFrequency)
	pExplosion.SetEffectLifeTime(1.0)
	###
	### Random Nano Nova Explosion ###
	fRandomNum = App.g_kSystemWrapper.GetRandomNumber(len(g_GfxSet["ExpNovaGfx"]))
	strFile = "scripts/Custom/NanoFX/ExplosionFX/Gfx/ExpNova/" + g_GfxSet["ExpNovaGfx"][fRandomNum]
	pExplosion.CreateTarget(strFile)
	###
	### Setup Properties ###
	pExplosion.SetTargetAlphaBlendModes(0, 7)
	pExplosion.SetEmitFromObject(pEmitFrom)
	pExplosion.SetEmitPositionAndDirection(bOwnsEmitFrom, bOwnsEmitFrom)
	pExplosion.SetDetachEmitObject(0)
	pExplosion.AttachEffect(pEffectRoot)
	###
	return App.EffectAction_Create(pExplosion)

###############################################################################
## Particle Effects,  Random pick of particle effect
###############################################################################
def CreateNanoParticles(fVelocity, fLife, fSize, pEmitFrom, kEmitPos, kEmitDir, pAttachTo):
	
	### Create Controller ###	
	pParticles = App.AnimTSParticleController_Create()
	###
	### Setup Particle Effect ###
	pParticles.AddColorKey(0.0, 1.0, 1.0, 1.0)
	pParticles.AddAlphaKey(0.0, 0.6)
	pParticles.AddAlphaKey(0.5, 0.5)
	pParticles.AddAlphaKey(1.0, 0.0)
	pParticles.AddSizeKey(0.0, 0.2 * fSize)
	pParticles.AddSizeKey(0.6, 1.0 * fSize)
	pParticles.AddSizeKey(0.9, 2.0 * fSize)
	pParticles.SetEmitVelocity(fVelocity)
	pParticles.SetAngleVariance(200.0)
	###
	### Setup Animation ###
	fFrequency = 0.2
	pParticles.SetEmitLife(g_GFX_FPS / 21)
	pParticles.SetEmitFrequency(fFrequency)
	pParticles.SetEffectLifeTime(4)
	pParticles.SetDrawOldToNew(0)
	###
	### Random Nano Particle Effect ###
	fRandomNum = App.g_kSystemWrapper.GetRandomNumber(len(g_GfxSet["ParticleGfx"]))
	strFile = "scripts/Custom/NanoFX/ExplosionFX/Gfx/Particles/" + g_GfxSet["ParticleGfx"][fRandomNum]
	pParticles.CreateTarget(strFile)
	###
	### Setup Properties ###
	pParticles.SetEmitFromObject(pEmitFrom)
	pParticles.SetEmitPositionAndDirection(kEmitPos, kEmitDir)
	pParticles.SetInheritsVelocity(0)
	pParticles.AttachEffect(pAttachTo)
	###
	return App.EffectAction_Create(pParticles)

###############################################################################
## Spark Effects,  Random pick of particle effect
###############################################################################
def CreateNanoSparks(fDuration, pEvent, pEffectRoot):
	
	### Create Controller ###	
	fEmitRate = 0.005
	pSpark = App.SparkParticleController_Create(fDuration + (App.g_kSystemWrapper.GetRandomNumber(15) + 20) * fEmitRate, fDuration, fEmitRate)
	###
	# Setup some default values for velocity, colors and alpha
	pSpark.AddColorKey(0.0, 1.0, 1.0, 0.8)
	pSpark.AddColorKey(0.5, 1.0, 1.0, 0.6)
	pSpark.AddColorKey(1.0, 1.0, 1.0, 0.0)
	###
	pSpark.AddAlphaKey(0.0, 1.0)
	pSpark.AddAlphaKey(0.5, 0.9)
	pSpark.AddAlphaKey(1.0, 0.0)
	###
	pSpark.AddSizeKey(0.0, 0.01)
	pSpark.AddSizeKey(0.2, 0.04)
	pSpark.AddSizeKey(0.8, 0.04)
	pSpark.AddSizeKey(1.0, 0.01)
	###
	pSpark.SetEmitVelocity(2.5)
	pSpark.SetTailLength(0.2 * (App.g_kSystemWrapper.GetRandomNumber(2) + 1))
	###
	pSpark.SetAngleVariance(120.0)
	pSpark.SetEmitLifeVariance(fDuration / 4.0)
	pSpark.CreateTarget("data/sphere.tga")
	###
	pTargetObject = pEvent.GetTargetObject()
	kEmitPos = pEvent.GetObjectHitPoint()
	kEmitDir = pEvent.GetObjectHitNormal()
	pSpark.SetEmitFromObject(App.TGModelUtils_CastNodeToAVObject(pTargetObject.GetNode()))
	pSpark.SetEmitPositionAndDirection(kEmitPos, kEmitDir)
	###
	pSpark.SetDetachEmitObject(0)
	pSpark.SetDamping(0.3)
	pSpark.AttachEffect(pEffectRoot)
	###
	return	App.EffectAction_Create(pSpark)	

###############################################################################
## New Sequences...
###############################################################################
###############################################################################
###############################################################################
## Weapon Explosion Sequence
###############################################################################
def CreateNanoWeaponExpSeq(fSize, fLife, pEvent):
	
	### Create Sequence Object ###	
	pSequence = App.TGSequence_Create()
	iNumPlume = 2
	###
	pTargetObject = pEvent.GetTargetObject()
	kEmitPos = pEvent.GetObjectHitPoint()
	kEmitDir = pEvent.GetObjectHitNormal()
	###
	pAttachTo = pTargetObject.GetNode()
	pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pAttachTo)
	###
	if (App.g_kSystemWrapper.GetRandomNumber(100) < 25):

		### Create Nano's Large Explosion /w Sound ###
		pSound = CreateNanoSoundSeq(pTargetObject, "ExpLargeSfx")
		pSequence.AddAction(pSound)
		pExplosion = CreateNanoExp(fLife, fSize, pEmitFrom, kEmitPos, kEmitDir, pAttachTo)
		pSequence.AddAction(pExplosion)
	###	
	### Create Nano's Small Explosion Sound ###
	pSound = CreateNanoSoundSeq(pTargetObject, "ExpSmallSfx")
	pSequence.AddAction(pSound)
	###
	for iPoint in range( iNumPlume ):
		pExplosion = CreateNanoExpPlume(120.0, fLife, fSize, pEmitFrom, kEmitPos, kEmitDir, pAttachTo)
		pSequence.AddAction(pExplosion)
	###	
	return pSequence

###############################################################################
## Particle Sequence
###############################################################################
def CreateNanoParticleSeq(fDuration, fSize, pEvent, pEffectRoot):

	### Create Sequence Object ###		
	pSequence = App.TGSequence_Create()
	###
	pTargetObject = pEvent.GetTargetObject()
	kEmitPos = pEvent.GetObjectHitPoint()
	kEmitDir = pEvent.GetObjectHitNormal()
	###
	fSize = pTargetObject.GetRadius() * 0.1
	###
	pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pTargetObject.GetNode())
	pParticle = CreateNanoParticles(0.2, 2.0 + App.g_kSystemWrapper.GetRandomNumber(30) / 10.0, fSize, pEmitFrom, kEmitPos, kEmitDir, pEffectRoot)
	pSequence.AddAction(pParticle)
	###
	return pSequence	

###############################################################################
## Random Rotation Sequence 
###############################################################################
def CreateNanoRotationSeq(pObject, fRotation, fSpeed):
	
	### Create Sequence Object ###	
	pSequence = App.TGSequence_Create()
	###	
	fRotation = App.g_kSystemWrapper.GetRandomNumber(fRotation) + fRotation
	fRotation = fRotation * 0.01
	###	
	pSequence.AddAction(App.TGScriptAction_Create(__name__, "SetNanoRotation", pObject, fRotation, fSpeed ))
	###
	return pSequence

###############################################################################
## Flicker Lights Sequence
###############################################################################
def CreateFlickerSeq(pObject, fTotalTime, fFlickerSpeed, sStatus):
	
	### Create Sequence Object ###	
	pSequence = App.TGSequence_Create()
	###
	fFlickerTime = 0
	###
	while (fFlickerTime < fTotalTime - 0.1):
		pSequence.AddAction(App.TGScriptAction_Create(__name__, "TurnOffLights", pObject), App.TGAction_CreateNull(), App.g_kSystemWrapper.GetRandomNumber(100) * 0.001 + fFlickerTime)
		pSequence.AddAction(App.TGScriptAction_Create(__name__, "TurnOnLights"), App.TGAction_CreateNull(), App.g_kSystemWrapper.GetRandomNumber(100) * 0.001 + fFlickerTime)
		fFlickerTime = fFlickerTime + fFlickerSpeed
	###
	if sStatus == "Off":
		pSequence.AddAction(App.TGScriptAction_Create(__name__, "TurnOffLights", pObject), App.TGAction_CreateNull(), fTotalTime)
	if sStatus == "On":	
		pSequence.AddAction(App.TGScriptAction_Create(__name__, "TurnOnLights"), App.TGAction_CreateNull(), fTotalTime)
	###
	return pSequence

###############################################################################
##  Create Nova WarpCore Nano Explosion Sequence
###############################################################################
def CreateNanoExpNovaSeq(pShip, fSize):
	### Create Sequence Object ###
	pSequence = App.TGSequence_Create()
	pSet = pShip.GetContainingSet()
	###
	### Setup for Effect ###
	fRadius = pShip.GetRadius()
	pAttachTo 	 = pSet.GetEffectRoot()
	pEmitFrom 	 = App.TGModelUtils_CastNodeToAVObject(pShip.GetNode())
	pWarpcore 	 = pShip.GetPowerSubsystem()
	pWarpcoreEmitPos = pWarpcore.GetPosition()
	vEmitDir = App.NiPoint3((App.g_kSystemWrapper.GetRandomNumber(200) - 100) * 0.01, (App.g_kSystemWrapper.GetRandomNumber(200) - 100) * 0.01, (App.g_kSystemWrapper.GetRandomNumber(200) - 100) * 0.01)
	fFlashColor   = GetOverrideColor(pShip, "ExpFX")
	iShow = 0.0
	if pShip.GetName() == "Player" or pShip.GetName() == "player":
		iShow = 2.0
	if (fFlashColor == None):
		sRace 			= GetSpeciesName(pShip)
		fFlashColor 	= GetRaceTextureColor(sRace)
	###
	if fSize != 1:
		sFile = GetNanoGfxFile("NovaSphereGfx", "scripts/Custom/NanoFXv2/ExplosionFX/Gfx/NovaSphere/")
		pExplosion = CreateControllerFX(sFile, pEmitFrom, pAttachTo, fSize * (3.0 + iShow), pWarpcoreEmitPos, iTiming = 28)
		pSequence.AddAction(pExplosion, App.TGAction_CreateNull(), 0.5)
		sFile = GetNanoGfxFile("NovaFlashGfx", "scripts/Custom/NanoFXv2/ExplosionFX/Gfx/NovaFlash/")
		pExplosion = CreateControllerFX(sFile, pEmitFrom, pAttachTo, fSize * (3.0 + iShow), pWarpcoreEmitPos, iTiming = 20)
		pSequence.AddAction(pExplosion)
		pNova = CreateNanoExpNova(pShip, fSize)
		pSequence.AddAction(pNova)
		### Create Nano's Nova Explosion Sound ###
		pSound = CreateNanoSoundSeq(pShip, "ExpNovaSfx")
		pSequence.AddAction(pSound)
		###
		### Damage the model with Warp Core Explosion ###
		pSequence.AddAction(App.TGScriptAction_Create(__name__, "NanoDamageShip", pShip, pEmitFrom, pShip.GetRadius(), 600.0), App.TGAction_CreateNull(), 0.7)
	else:
		fSize = pShip.GetRadius() / 1.2
		### Create Nano's Nova Explosion Sound ###
		pSound = CreateNanoSoundSeq(pShip, "ExpLargeSfx")
		pSequence.AddAction(pSound)
		###
	iNovaSparks = Custom.NanoFXv2.NanoFX_Config.eFX_ExpSparkFXLevel * 7.0
	for iPoint in range( iNovaSparks ):
		fRand = App.g_kSystemWrapper.GetRandomNumber(100) *  0.01
		pSparks = CreateExpSparkSeq(fSize * (0.8 + fRand), pEmitFrom, pAttachTo, pWarpcoreEmitPos, vEmitDir)
		pSequence.AddAction(pSparks, App.TGAction_CreateNull(), 0.50)
	###
	return pSequence
def CreateNanoExpNova(pObject, fSize):
	
	### Create Sequence Object ###	
	pSequence = App.TGSequence_Create()
	pSet = pObject.GetContainingSet()
	###
	pEmitPos = App.TGModelUtils_CastNodeToAVObject(pObject.GetNode())
	pWarpcore = pObject.GetPowerSubsystem()
	pWarpcoreEmitPos = pWarpcore.GetPosition()
	pExplosion = CreateNanoWarpCoreExp(fSize * 5.0, 1.0, pEmitPos, pWarpcoreEmitPos, pSet.GetEffectRoot())
	pSequence.AddAction(pExplosion)
	### Damage the model with Warp Core Explosion ###
	pSequence.AddAction(App.TGScriptAction_Create(__name__, "NanoDamageShip", pEmitPos, pObject, pObject.GetRadius(), 1600.0), App.TGAction_CreateNull(), 0.2)
	### Create Nano's Nova Explosion Sound ###
	#pSound = CreateNanoSoundSeq(pObject, "ExpNovaSfx")
	#pSequence.AddAction(pSound)
	###
	return pSequence

def CreateExpSparkSeq(fSize, pEmitFrom, pAttachTo, vEmitPos, vEmitDir = None):

	### Create Sequence Object ###
	pSequence = App.TGSequence_Create()
	###
	vEmitDir = App.NiPoint3((App.g_kSystemWrapper.GetRandomNumber(200) - 100) * 0.01, (App.g_kSystemWrapper.GetRandomNumber(200) - 100) * 0.01, (App.g_kSystemWrapper.GetRandomNumber(200) - 100) * 0.01)
	for iNum in range(Custom.NanoFXv2.NanoFX_Config.eFX_ExpSparkFXLevel):
		if g_ParticleControl < CONST_MAXPARTICLES and g_SimultaneousControl < CONST_MAXSIMULTANEOUS:
			sFile = GetNanoGfxFile("ParticleGfx", "scripts/Custom/NanoFXv2/ExplosionFX/Gfx/Particles/")
			fRandomSize = App.g_kSystemWrapper.GetRandomNumber(5)
			fSize = fSize / 2
			fVelocity = 0.5 + fSize + App.g_kSystemWrapper.GetRandomNumber(fSize * 100 + fRandomSize) * 0.01
			pSparks = CreateControllerFX(sFile, pEmitFrom, pAttachTo, fSize, vEmitPos, vEmitDir, bInheritVel = 0, fEmitVel = fVelocity, fVariance = 150.0, fDamping = 1.0, sType = "ExpSparks")
			pSequence.AddAction(pSparks)
			ControlParticles(None, 1)
			pSequence.AddAction(App.TGScriptAction_Create(__name__, "ControlParticles", -1), App.TGAction_CreateNull(), 4.0)			
			ControlSimultaneous(None, 1)
			pSequence.AddAction(App.TGScriptAction_Create(__name__, "ControlSimultaneous", -1), App.TGAction_CreateNull(), 1.0)			
	###	
	return pSequence
def ControlParticles(pAction, iNum):
	
	global g_ParticleControl
	g_ParticleControl = g_ParticleControl + iNum
	#if g_ParticleControl >= CONST_MAXPARTICLES:
		#print "I have reached the Maximum of " + str(g_ParticleControl) + " Particles!"
		
	return 0
def ControlSimultaneous(pAction, iNum):
	
	global g_SimultaneousControl
	g_SimultaneousControl = g_SimultaneousControl + iNum
	#if g_SimultaneousControl >= CONST_MAXSIMULTANEOUS:
		#print "I have exceeded the Maximum of " + str(g_SimultaneousControl) + " Simultaneous Particles!"
		
	return 0
		
###############################################################################
##  Create Large Nano Explosion Sequence
###############################################################################
def CreateNanoExpLargeSeq(pObject, iNumPlume):
	
	### Create Sequence Object ###	
	pSequence = App.TGSequence_Create()
	###	
	pEmitPos = pObject.GetRandomPointOnModel()
	pExplosion = CreateNanoExp(1.0, pObject.GetRadius() * 0.75, pEmitPos, pEmitPos, -1, pObject.GetNode())
	pSequence.AddAction(pExplosion)
	for iPoint in range( iNumPlume ):
		pExplosion = CreateNanoExpPlume(120.0, 0.5, pObject.GetRadius()  * 0.75, pEmitPos, pEmitPos, -1, pObject.GetNode())
		pSequence.AddAction(pExplosion)
	###
	return pSequence

###############################################################################
##  Create Small Nano Explosions Sequence (Crack the Ship Like an EGG!)
###############################################################################
def CreateNanoExpSmallSeq(pObject, fTime):
	
	### Create Sequence Object ###	
	pSequence = App.TGSequence_Create()
	pSet = pObject.GetContainingSet()	
	iNumPlume = 2
	###
	fExplosionTime = 0.0
	while (fExplosionTime < fTime):
		### Create Nano's Explosion Sound ###
		pSound = CreateNanoSoundSeq(pObject, "ExpLargeSfx")
		pSequence.AddAction(pSound)
		###
		### Create Nano's Visual Smaller Explosions ###
		pEmitPos = pObject.GetRandomPointOnModel()
		fRadius  = pObject.GetRadius() * (App.g_kSystemWrapper.GetRandomNumber(40) + 20) * 0.01
		pExplosion = CreateNanoExp(1.0, fRadius, pEmitPos, pEmitPos, -1, pObject.GetNode())
		pSequence.AddAction(pExplosion)
		for iPoint in range( iNumPlume ):
			pExplosion = CreateNanoExpPlume(120.0, 0.5, fRadius, pEmitPos, pEmitPos, -1, pObject.GetNode())
			pSequence.AddAction(pExplosion)
		###		
		### Damage the model with these explosions ###
		pSequence.AddAction(App.TGScriptAction_Create(__name__, "NanoDamageShip", pEmitPos, pObject, pObject.GetRadius(), 1600.0), App.TGAction_CreateNull(), 0.5)
		###		
		fExplosionTime = fExplosionTime + 0.5
	###
	return pSequence

###############################################################################
## Create Sound Sequence 
###############################################################################
def CreateNanoSoundSeq(pObject, sSoundSet):
	
	### Create Sequence Object ###	
	pSequence = App.TGSequence_Create()
	pSet = pObject.GetContainingSet()
	###
	### Get a random sound from that group ###
	lSoundGroup = g_SfxSet[ sSoundSet ]
	sSound = Custom.NanoFX.ExplosionFX.ExpSfx.GetRandomSound( lSoundGroup )
	###
	### Add an action to play the sound. ###
	pSound = App.TGSoundAction_Create(sSound, 0, pSet.GetName())
	pSound.SetNode(pObject.GetNode())
	pSequence.AddAction(pSound)
	###
	return pSequence	
	
###############################################################################
## New Death Sequence by Nano
###############################################################################
def NanoDeathSeq(pShip):
	### Holds the Entire Death Sequence ###
	pFullSequence = App.TGSequence_Create()
	###
	### Setup Sequence Timing ###
	fTotalSequenceTime = 14
	fExplosionShift = -8.0
	###
	### Set up Exploding Ship Properties ###
	pExplodingShip = App.ShipClass_Cast(pShip)

	pExplodingShip.SetMass(50000)
	pExplodingShip.SetRotationalInertia(11000)

	if (pExplodingShip.GetName() == "Player") or (pExplodingShip.GetName() == "player"):
		pExplodingShip.SetLifeTime (fTotalSequenceTime)
		pWarpPower = pExplodingShip.GetPowerSubsystem()
		if pWarpPower.GetPowerOutput() > 0:
			pWarpPower = pExplodingShip.GetRadius() * 15
		else:
			pWarpPower = 15
		fRadius = pWarpPower
	else:
		pExplodingShip.SetLifeTime (fTotalSequenceTime / 2 + 1)
		pWarpPower = pExplodingShip.GetPowerSubsystem()
		pWarpPower = (pWarpPower.GetAvailablePower() * 0.025) + (pWarpPower.GetPowerOutput() * 0.075)
		pWarpPower = pWarpPower * Custom.NanoFXv2.NanoFX_Config.eFX_SplashRadius
		fRadius = pWarpPower / 50.0
		if pWarpPower:
			pExplodingShip.SetSplashDamage(pWarpPower, fRadius)
			#print("Setting splash damage for %s to (%f, %f)" % (pExplodingShip.GetName(), pExplodingShip.GetSplashDamage(), pExplodingShip.GetSplashDamageRadius()))
	###
	### Begin Death Sequence ###
	############################
	###
	### Flicker some lights ###
	if (Custom.NanoFXv2.NanoFX_Config.eFX_LightFlickerFX == "On"):
		pFullSequence.AddAction(CreateFlickerSeq(pExplodingShip, 3.0, 0.2, "Off"), App.TGAction_CreateNull(), 1.0)
	###
	# pObject, fTotalTime, fFlickerSpeed, sStatus
	### Create Nano's Initial Large explosions ###
	pFullSequence.AddAction(CreateNanoExpSmallSeq(pExplodingShip, 0.01), App.TGAction_CreateNull(), 0.2)
	pFullSequence.AddAction(CreateNanoExpLargeSeq(pExplodingShip, 2), App.TGAction_CreateNull(), fTotalSequenceTime - 3.2 + fExplosionShift)
	pFullSequence.AddAction(CreateNanoExpLargeSeq(pExplodingShip, 2), App.TGAction_CreateNull(), fTotalSequenceTime - 3.05 + fExplosionShift)
	pFullSequence.AddAction(CreateNanoExpLargeSeq(pExplodingShip, 2), App.TGAction_CreateNull(), fTotalSequenceTime - 2.85 + fExplosionShift)
	###
	### Destroy Model into Debris Parts ###
	pFullSequence.AddAction(CreateNanoExpSmallSeq(pExplodingShip, 2.0), App.TGAction_CreateNull(), fTotalSequenceTime - 1.7 + fExplosionShift)
	###
	### Add Random Spin to Model ###
	if (Custom.NanoFXv2.NanoFX_Config.eFX_RotationFX == "On"):
		pFullSequence.AddAction(CreateRotationSeq(pExplodingShip, 700), App.TGAction_CreateNull(), 0.3)
		pFullSequence.AddAction(CreateRotationSeq(pExplodingShip, 1000, 0.5), App.TGAction_CreateNull(), fTotalSequenceTime - 1.6 + fExplosionShift)
	###
	### Create Nano's Warp Core Explosion ###
	pFullSequence.AddAction(CreateNanoExpNovaSeq(pExplodingShip, fRadius / 15), App.TGAction_CreateNull(), fTotalSequenceTime - 1.7 + fExplosionShift)
	#pFullSequence.AddAction(ShakeSequence(1.5), App.TGAction_CreateNull(), fTotalSequenceTime - 1.3 + fExplosionShift)
	###
	### Create Nano's Final Explosions ###
	pFullSequence.AddAction(CreateNanoExpLargeSeq(pExplodingShip, 2), App.TGAction_CreateNull(), fTotalSequenceTime - 1.95 + fExplosionShift)
	pFullSequence.AddAction(CreateNanoExpLargeSeq(pExplodingShip, 2), App.TGAction_CreateNull(), fTotalSequenceTime - 1.85 + fExplosionShift)
	pFullSequence.AddAction(CreateNanoExpLargeSeq(pExplodingShip, 2), App.TGAction_CreateNull(), fTotalSequenceTime - 1.65 + fExplosionShift)
	
	###
	#pFullSequence.SetUseRealTime(1)
	pFullSequence.AppendAction(App.TGScriptAction_Create(__name__, "DestroyTGSequence", pFullSequence), fTotalSequenceTime)
	pFullSequence.Play()
	bFound = 0
	return
###############################################################################
## New Event Handling...
###############################################################################
###############################################################################
###############################################################################
## Torpedo Hitting Shield Event
###############################################################################
def NanoTorpedoShieldHit(TGObject, pEvent):
	
	### Set up ###
	pObject = App.ObjectClass_Cast(TGObject)
	pSet = pObject.GetContainingSet()
	pSequence = App.TGSequence_Create()
	###
	### Create Explosion Seq ###
	pExplosion = CreateNanoWeaponExpSeq(pEvent.GetRadius() * 2.0, 1.0, pEvent)
	pSequence.AddAction(pExplosion)
	###
	pSequence.SetUseRealTime(1)
	pSequence.Play()
	###
	TGObject.CallNextHandler(pEvent)

###############################################################################
## Torpedo Hitting Hull Event
###############################################################################
def NanoTorpedoHullHit(TGObject, pEvent):
	
	### Set up ###
	pObject = App.ObjectClass_Cast(TGObject)
	pSet = pObject.GetContainingSet()
	pSequence = App.TGSequence_Create()
	###
	### Create Explosion Seq ###
	pExplosion = CreateNanoWeaponExpSeq(pEvent.GetRadius() * 3.0, 1.0, pEvent)
	pSequence.AddAction(pExplosion)
	###
	### Sparks 30% Chance and Particles 10% Chance ###
	if (App.EffectController_GetEffectLevel() >= App.EffectController.MEDIUM):
		if (App.g_kSystemWrapper.GetRandomNumber(100) < 30):
			pSparks = CreateNanoSparks(1.0, pEvent, pSet.GetEffectRoot())
			pSequence.AddAction(pSparks)

		if (App.g_kSystemWrapper.GetRandomNumber(100) < 10):
			pParticle = CreateNanoParticleSeq(1.0, 0.3, pEvent, pSet.GetEffectRoot())	
			pSequence.AddAction(pParticle, App.TGAction_CreateNull(), 0.5)
	###
	### Add Rotational Spin to Ship From Torp Explosion 25% Chance##
	if (App.g_kSystemWrapper.GetRandomNumber(100) < 25):
		if (pEvent.GetDamage() >= 200):
			pShip = App.ShipClass_Cast(pEvent.GetTargetObject())
			pSequence.AddAction(CreateNanoRotationSeq(pShip, pEvent.GetDamage(), -1))
			pSequence.AddAction(CreateFlickerSeq(pShip, 1.0, 0.2, "On"))
	###
	pSequence.SetUseRealTime(1)
	pSequence.Play()
	###
	TGObject.CallNextHandler(pEvent)

###############################################################################
## Phaser Hitting Hull Event
###############################################################################
def NanoPhaserHullHit(TGObject, pEvent):
	
	### Set up ###
	pObject = App.DamageableObject_Cast(TGObject)
	pSet = pObject.GetContainingSet()
	pSequence = App.TGSequence_Create()
	###
	### Create an Explosion 50% Chance ###
	if (App.g_kSystemWrapper.GetRandomNumber(100) < 50):
		pExplosion = CreateNanoWeaponExpSeq(pEvent.GetRadius() * 2.0, 1.0, pEvent)
		pSequence.AddAction(pExplosion)
	###
	### Sparks 20% Chance ###
	if (App.EffectController_GetEffectLevel() >= App.EffectController.MEDIUM):
		if (App.g_kSystemWrapper.GetRandomNumber(100) < 20):
			pSparks = CreateNanoSparks(1.0, pEvent, pSet.GetEffectRoot())
			pSequence.AddAction(pSparks)
	### Add Flicker Lights 10% Chance##
	if (App.g_kSystemWrapper.GetRandomNumber(100) < 10):
		pShip = App.ShipClass_Cast(pEvent.GetTargetObject())
		pSequence.AddAction(CreateFlickerSeq(pShip, 0.6, 0.2, "On"))
	###
	pSequence.SetUseRealTime(1)
	pSequence.Play()
	###
	TGObject.CallNextHandler(pEvent)
	
###############################################################################
## Collision Event
###############################################################################
def NanoCollisionEffect(TGObject, pEvent):
	
	### Setup ###
	pSet = TGObject.GetContainingSet()
	pEffectRoot = pSet.GetEffectRoot()
	pSequence = App.TGSequence_Create()
	###
	### Get the collision points ###
	for iPoint in range( pEvent.GetNumPoints() ):
		pPoint = pEvent.GetPoint(iPoint)

		### Add an explosion at this point ###
		pCollision = CreateNanoCollisionExp(2.5, pPoint, App.TGPoint3_GetRandomUnitVector(), pEffectRoot)
		pSequence.AddAction(pCollision)
		pSound = CreateNanoSoundSeq(TGObject, "ExpCollisionSfx")
		pSequence.AddAction(pSound)
	###
	pSequence.SetUseRealTime(1)
	pSequence.Play()
	###
	TGObject.CallNextHandler(pEvent)
		
###############################################################################
## Turn Off Lights 
###############################################################################
def TurnOffLights(pAction, pObject):
	
	### Turn off Glows ###	
	pObject.DisableGlowAlphaMaps()
	###
	return (0)

###############################################################################
## Turn On Lights 
###############################################################################
def TurnOnLights(pAction):
	
	### Quickly Turn off Game Glow Maps then Back on ###
	if (App.g_kLODModelManager.AreGlowMapsEnabled() == 1):
		App.g_kLODModelManager.SetGlowMapsEnabled(0)
		App.g_kLODModelManager.SetGlowMapsEnabled(1)
	###
	return (0)

###############################################################################
## Damage the Model
###############################################################################
def NanoDamageShip(pAction, pEmitPos, pObject, fRadius, fDamage):
	
	### Put Holes in our Model ###
	pObject.AddDamage(pEmitPos, fRadius * 0.4, fDamage)
	###
	return (0)

###############################################################################
## Random Rotation & Speed... Based on "Brownielini" RandRotation Function
###############################################################################
def SetNanoRotation(pAction, pShip, fRotation, fSpeed):
	
	### Create some vectors ###
	vNewVelocity = App.TGPoint3()
	###
	### Set Random Speed ###
	if (fSpeed >= 0):
		vNewVelocity.SetX(fSpeed)
		vNewVelocity.SetY(fSpeed)
		vNewVelocity.SetZ(fSpeed)
		pShip.SetVelocity(vNewVelocity)
	###
	### Set it to a random spin direction... ###
	vNewVelocity.SetX((App.g_kSystemWrapper.GetRandomNumber(20001) - 10000) / 10000.0)
	vNewVelocity.SetY((App.g_kSystemWrapper.GetRandomNumber(20001) - 10000) / 10000.0)
	vNewVelocity.SetZ((App.g_kSystemWrapper.GetRandomNumber(20001) - 10000) / 10000.0)
	###
	### Add New Velocity to Current Velocity ###
	vCurVelocity = pShip.GetAngularVelocityTG()
	vNewVelocity.SetX(vNewVelocity.GetX() + vCurVelocity.GetX())
	vNewVelocity.SetY(vNewVelocity.GetY() + vCurVelocity.GetY())
	vNewVelocity.SetZ(vNewVelocity.GetZ() + vCurVelocity.GetZ())
	###
	### Set the length to the specified speed ###
	vNewVelocity.Unitize()
	vNewVelocity.Scale( fRotation * App.HALF_PI / 180.0 )
	pShip.SetAngularVelocity(vNewVelocity, App.PhysicsObjectClass.DIRECTION_WORLD_SPACE)
	###
	return (0)
###############################################################################
## Get Override Color in Ship Plugin
##
## Args: pShip       - The Ship Object
##		 sEffectType - NanoFX type to Override
##       
##	 Return	     - Returns an RGB Color found in Plugin
###############################################################################
def GetOverrideColor(pShip, sEffectType):

	import string
	import Foundation
	
	try:
		pShipScript = string.split(pShip.GetScript(), ".")
		pShipDef = Foundation.shipList[pShipScript[-1]]
	except:
		return None
	
	if sEffectType == "ExpFX":
		if pShipDef.__dict__.has_key("OverrideExpFXColor"):
			return pShipDef.OverrideExpFXColor(None)
		else:
			return None
			
	if sEffectType == "PlasmaFX":
		if pShipDef.__dict__.has_key("OverridePlasmaFXColor"):
			return pShipDef.OverridePlasmaFXColor(None)
		else:
			return None
			
	if sEffectType == "WarpFX":
		if pShipDef.__dict__.has_key("OverrideWarpFXColor"):
			return pShipDef.OverrideWarpFXColor(None)
		else:
			return None


###############################################################################
## Get Race Texture Color 
##
## Args: sRace       - The String Race Name
##       
##	 Return	     - Returns an RGB Color.... if none found it returns Default Color
###############################################################################
def GetRaceTextureColor(sRace):
	
	try:
		dRGB  = { "Federation" : ( 55.0, 120.0, 255.0),
					"Klingon"    : (255.0,  20.0,   0.0),
					"Romulan"    : (  0.0, 248.0, 130.0),
					"Cardassian" : (255.0, 200.0,   0.0),
					"Ferengi"    : (255.0, 180.0,   0.0),
					"Kessok"     : (182.0,   0.0, 201.0),
					"Dominion"   : (182.0,   0.0, 201.0),
                	"Borg"       : (  0.0, 248.0, 150.0)
			}
		return dRGB[sRace]
	except:
		sRace = "Default"
		dRGB  = { "Default"    : (155.0, 120.0, 255.0)
			}
		return dRGB[sRace]
def GetSpeciesName(pShip):

	import Foundation
	import string
	
	try:
		pShipScript = string.split(pShip.GetScript(), ".")
	
		pShipDef = Foundation.shipList[pShipScript[-1]]
		sRaceName = pShipDef.race.name
	except:
		sRaceName = "Default"
	
	return sRaceName
def CreateRotationSeq(pShip, fRotation = None, fSpeed = None):

	### Create Sequence Object ###
	pSequence = App.TGSequence_Create()
	###
	fRotation = App.g_kSystemWrapper.GetRandomNumber(fRotation) + fRotation
	fRotation = fRotation * 0.01
	###
	pSequence.AddAction(App.TGScriptAction_Create(__name__, "SetNanoRotation", pShip, fRotation, fSpeed))
	###
	return pSequence
	###
def SetNanoRotation(pAction, pShip, fRotation, fSpeed):

	### Create some vectors ###
	vNewVelocity = App.TGPoint3()
	###
	### Set Speed ###
	if (fSpeed):
		vNewVelocity.SetX(fSpeed)
		vNewVelocity.SetY(fSpeed)
		vNewVelocity.SetZ(fSpeed)
		pShip.SetVelocity(vNewVelocity)
	###
	### Set it to a random spin direction... ###
	if (fRotation):
		vNewVelocity.SetX((App.g_kSystemWrapper.GetRandomNumber(20001) - 10000) / 10000.0)
		vNewVelocity.SetY((App.g_kSystemWrapper.GetRandomNumber(20001) - 10000) / 10000.0)
		vNewVelocity.SetZ((App.g_kSystemWrapper.GetRandomNumber(20001) - 10000) / 10000.0)
		###
		### Add New Velocity to Current Velocity ###
		vCurVelocity = pShip.GetAngularVelocityTG()
		vCurVelocity.Add(vNewVelocity)
		###
		### Set the length to the specified speed ###
		vCurVelocity.Unitize()
		vCurVelocity.Scale( fRotation * App.HALF_PI / 180.0 )
		pShip.SetAngularVelocity(vCurVelocity, App.PhysicsObjectClass.DIRECTION_WORLD_SPACE)
		###
	###
	return 0
	###
def DestroyTGSequence(pAction, pSequence):
	
	if pSequence:
		pSequence.Destroy()
	
	return 0
def CreateControllerFX( sFile, 
						pEmitFrom, 
						pAttachTo,
						fSize       = 1.0,
						vEmitPos    = App.NiPoint3(0, 0, 0),
						vEmitDir    = App.NiPoint3(0, 0, 0),
						bInheritVel = 0, 
						bDetach     = 0,
						fFrequency  = 0.2,   
						fLifeTime   = 0.1,
						fEmitVel    = None,
						fVariance   = None,
						fDamping    = None,
						vGravity    = None,
						iTiming     = 32,
						sType	    = "Normal",
						fRed	    = 255.0,
						fGreen      = 255.0,
						fBlue       = 255.0,
						fBrightness = 0.6):

	### Setup Controller Type ###
	pController = SetupController(sType, fSize, fLifeTime, fRed, fGreen, fBlue, fBrightness)
	###
	### Setup Animation ###
	fSpeed = iTiming / 15.0
	if sType != "ExpSparks" and sType != "DamageSparks" and sType != "Debris":
		pController.SetEmitLife(fSpeed)
		pController.SetEmitFrequency(fFrequency)
		pController.SetEffectLifeTime(fSpeed + fLifeTime)
	###
	pController.CreateTarget(sFile)
	###
	### Setup Properties ###
	if fEmitVel:
		pController.SetEmitVelocity(fEmitVel)
	if fVariance:
		pController.SetAngleVariance(fVariance)
		pController.SetEmitRadius(fSize / 4.0)
	if fDamping:
		pController.SetDamping(fDamping)
	if vGravity:
		pController.SetGravity(vGravity.GetX(), vGravity.GetY(), vGravity.GetZ())
	if sType != "Plume" and sType != "ExpSparks" and sType != "DamageSparks" and sType != "Debris":
		if sType == "Blinker" or sType == "StaticBlinker" or sType == "Plasma" or sType == "Normal":
			pController.SetTargetAlphaBlendModes(0, 0)
		else:
			pController.SetTargetAlphaBlendModes(0, 7)
	if pEmitFrom:
		pController.SetEmitFromObject(pEmitFrom)
	pController.SetEmitPositionAndDirection(vEmitPos, vEmitDir)
	pController.SetInheritsVelocity(bInheritVel)
	pController.SetDetachEmitObject(bDetach)
	pController.AttachEffect(pAttachTo)
	###
	return App.EffectAction_Create(pController)
	###

###############################################################################
## Setup Controller Type
###############################################################################
def SetupController(sType, fSize, fLifeTime, fRed, fGreen, fBlue, fBrightness):
	
	### Create Controller based on Type ###
	if (sType == "Normal" or sType == "Plasma"):
		pController = App.AnimTSParticleController_Create()
		###
		### Setup Alpha Colors ###
		pController.AddColorKey(0.1, 1.0, 1.0, 1.0)
		pController.AddColorKey(fBrightness, fRed / 255, fGreen / 255, fBlue / 255)
		pController.AddColorKey(1.0, 0.0, 0.0, 0.0)
		###
		pController.AddAlphaKey(0.0, 1.0)
		pController.AddAlphaKey(0.7, 0.5)
		pController.AddAlphaKey(1.0, 0.0)
		###
		### Setup Sizes ###
		fRandSize = App.g_kSystemWrapper.GetRandomNumber(10) * 0.01
		pController.AddSizeKey(0.0, 1.0 * fSize + fRandSize)
		pController.AddSizeKey(1.0, 1.0 * fSize + fRandSize)
	###
	if (sType == "Plume"):
		pController = App.ExplosionPlumeController_Create()
		###
		### Setup Alpha Colors ###
		### Setup Plume Effect ###
		pController.AddColorKey(0.0, fRed / 255, fGreen / 255, fBlue / 255)
		pController.AddColorKey(1.0, 0.0, 0.0, 0.0)
		###
		pController.AddAlphaKey(0.0, 1.0)
		pController.AddAlphaKey(0.7, 0.5)
		pController.AddAlphaKey(1.0, 0.0)
		### Setup Sizes ###
		fRandSize = App.g_kSystemWrapper.GetRandomNumber(20) * 0.01
		pController.AddSizeKey(0.0, 1.0 * fSize + fRandSize)
		pController.AddSizeKey(1.0, 1.0 * fSize + fRandSize)
	###
	if (sType == "Blinker"):
		pController = App.AnimTSParticleController_Create()
		###
		### Setup Alpha Colors ###
		### Setup Plume Effect ###
		pController.AddColorKey(0.0, fRed / 255, fGreen / 255, fBlue / 255)
		pController.AddColorKey(1.0, 0.0, 0.0, 0.0)
		###
		pController.AddAlphaKey(0.0, 1.0)
		pController.AddAlphaKey(1.0, 1.0)
		### Setup Sizes ###
		pController.AddSizeKey(0.0, fSize)
		pController.AddSizeKey(1.0, fSize)
	###
	if (sType == "StaticBlinker"):
		pController = App.AnimTSParticleController_Create()
		###
		### Setup Alpha Colors ###
		### Setup Plume Effect ###
		pController.AddColorKey(0.0, fRed / 255, fGreen / 255, fBlue / 255)
		pController.AddColorKey(1.0, fRed / 255, fGreen / 255, fBlue / 255)
		###
		pController.AddAlphaKey(0.0, 1.0)
		pController.AddAlphaKey(1.0, 1.0)
		### Setup Sizes ###
		pController.AddSizeKey(0.0, fSize)
		pController.AddSizeKey(1.0, fSize)
	###
	if (sType == "Debris"):
		### Create Controller ###
		fEmitRate = 0.005
		fDuration = fLifeTime
		pController = App.DebrisParticleController_Create(fDuration * (1.1295 - fDuration * 0.00003) + (App.g_kSystemWrapper.GetRandomNumber(10) * 0.001), fDuration, fEmitRate)
		pController.SetEmitLifeVariance(fDuration / 4.0)
		###
		# Setup some default values for velocity, colors and alpha
		pController.AddColorKey(0.0, 1.0, 1.0, 1.0)
		pController.AddColorKey(1.0, 0.0, 0.0, 0.0)
		###
		pController.AddAlphaKey(0.0, 0.8 + App.g_kSystemWrapper.GetRandomNumber(3) * 0.1)
		pController.AddAlphaKey(1.0, 0.0)
		###
		fRandomSize = App.g_kSystemWrapper.GetRandomNumber(5) + 5
		pController.AddSizeKey(0.0, 0.01)
		pController.AddSizeKey(0.2, fRandomSize * fSize * 0.01)
		pController.AddSizeKey(0.7, fRandomSize * fSize * 0.01)
		pController.AddSizeKey(1.0, 0.01)
		###
	if (sType == "ExpSparks") or (sType == "DamageSparks"):	
		### Create Controller ###
		if sType == "ExpSparks":
			fEmitRate = 0.005
			fDuration = 3.0 + App.g_kSystemWrapper.GetRandomNumber(100) * 0.01
			pController = App.SparkParticleController_Create(fDuration * 1.1345 + (App.g_kSystemWrapper.GetRandomNumber(25) * 0.001), fDuration, fEmitRate)
			pController.SetTailLength(0.05 * (App.g_kSystemWrapper.GetRandomNumber(2) + 1))
		else:
			fEmitRate = 0.5
			fDuration = fLifeTime
			pController = App.SparkParticleController_Create(fDuration, 1.0, fEmitRate)
			pController.SetTailLength(0.02)
		###
		# Setup some default values for velocity, colors and alpha
		pController.SetEmitLifeVariance(fDuration / 4.0)
		pController.AddColorKey(0.0, 1.0, 1.0, 0.9)
		pController.AddColorKey(0.6, 1.0, 0.8, 0.5)
		pController.AddColorKey(1.0, 0.5, 0.2, 0.0)
		###
		pController.AddAlphaKey(0.0, 1.0)
		pController.AddAlphaKey(0.6, 0.5)
		pController.AddAlphaKey(1.0, 0.0)
		###
		fRandomSize = App.g_kSystemWrapper.GetRandomNumber(10)
		pController.AddSizeKey(0.0, 0.01)
		pController.AddSizeKey(0.2, 0.03 * fSize * 0.75)
		pController.AddSizeKey(0.8, 0.05 * fSize * 0.75)
		pController.AddSizeKey(1.0, 0.01)
		###
	if (sType == "Atmosphere"):
		pController = App.AnimTSParticleController_Create()
		###
		### Setup Alpha Colors ###
		pController.AddColorKey(0.0, fRed / 255, fGreen / 255, fBlue / 255)
		pController.AddColorKey(1.0, 0.0, 0.0, 0.0)
		pController.AddAlphaKey(0.0, 1.0)
		pController.AddAlphaKey(1.0, 1.0)
		###
		### Setup Sizes ###
		pController.AddSizeKey(0.0, 2.0 * fSize)
		pController.AddSizeKey(1.0, 2.0 * fSize)
		###
	###
	return pController
	###
		
###############################################################################
## End of ExplosionFX
###############################################################################
