###############################################################################
##	Filename:	ExpGfx.py
##	
##	Nano's Explosion Gfx Dynamic Loading Version 1.0
##	
##	Created:	03/11/2003 - NanoByte a.k.a Michael T. Braams
###############################################################################
import App
import nt 

###############################################################################
## Load Nano's New Effect Textures
###############################################################################
def LoadNanoExpGfx(Icons = None):

	### Setup ###
	if(Icons is None):
		Icons = App.g_kIconManager.CreateIconGroup("EffectTextures")
		# Add group to manager.
		App.g_kIconManager.AddIconGroup(Icons)
	###
	### Load Default Space Dust Texture... for some reason effects.py doesn't load it! ###
	kTexture = Icons.LoadIconTexture("data/Textures/spacedust.tga")
	Icons.SetIconLocation(10, kTexture, 0, 0, 16, 16)
	###
	### Load the Gfx files into BC
	LoadGfxFiles("Explosions", 8, 4)
	LoadGfxFiles("ExpNova", 8, 4)
	LoadGfxFiles("Particles", 8, 4)
	###

###############################################################################
## Load New Damage Textures into BC 
###############################################################################
def LoadNanoDamageGfx(Icons = None):
	
	if(Icons is None):
		Icons = App.g_kIconManager.CreateIconGroup("DamageTextures")
		App.g_kIconManager.AddIconGroup(Icons)

	sFileNames = GetFileNames("Damage")
	
	for loadIndex in range(len(sFileNames)):
		strFile = "scripts/Custom/NanoFX/ExplosionFX/Gfx/Damage/" + sFileNames[loadIndex]
		kTexture = Icons.LoadIconTexture(strFile)
		Icons.SetIconLocation(loadIndex, kTexture, 0, 0, 64, 64)

###############################################################################
## Get File Names from Folder 
###############################################################################
def GetFileNames(sFolderPath): 
      
     	sFileList = nt.listdir("scripts\\Custom\\NanoFX\\ExplosionFX\\Gfx\\" + sFolderPath) 
     	sFileList.sort() 
 
     	return sFileList
	
###############################################################################
## Function to load Textures into BC 
###############################################################################	
def LoadGfxFiles(sEffectType, iNumXFrames, iNumYFrames):

	sFileNames = GetFileNames(sEffectType)
	
	for loadIndex in sFileNames:
		strFile = "scripts/Custom/NanoFX/ExplosionFX/Gfx/" + sEffectType + "/" + loadIndex
		
		fX = 0.0
		fY = 0.0

		pContainer = App.g_kTextureAnimManager.AddContainer(strFile)
			
		### Load a Normal X * Y Frame Explosion Effect ###
		pTrack = pContainer.AddTextureTrack(iNumXFrames * iNumYFrames)
			
		for index in range(iNumXFrames * iNumYFrames - 1):
			pTrack.SetFrame(index, fX, fY + (1.0 / iNumYFrames), fX + (1.0 / iNumXFrames), fY)
			fX = fX + (1.0 / iNumXFrames)
		
			if (fX == 1.0):
				fX = 0.0
				fY = fY + (1.0 / iNumYFrames)	
		###
###############################################################################
## End of Loading Exp Gfx
###############################################################################